<template>
  <div>
    <el-input
              v-model="search"
              prefix-icon="el-icon-search"
              style="margin-top:15px;width:300px;"
              placeholder="Type to search"/>
    <el-button
              type="danger"
              style="margin-left:15px;"
              @click="handleDeleteAll()">Delete All</el-button>
    <el-table
              :data="tableData.filter(data => !search || data.title.toLowerCase().includes(search.toLowerCase()))"
              height="450"
              style="width: 95%;margin: 10px">
      <el-table-column
              label="Title">
              <template slot-scope="scope">
                <h3>{{scope.row.title}}</h3>
              </template>
      </el-table-column>
      <el-table-column
              label="Description">
              <template slot-scope="scope">
                <p class="text-cut">{{scope.row.description}}</p>
              </template>
      </el-table-column>
      <el-table-column
                label="Status">
                <template slot-scope="scope">
                  <el-tag
                    :type="scope.row.status === 'pending' ? 'primary' : 'success'"
                    disable-transitions>{{scope.row.status}}</el-tag>
                </template>
      </el-table-column>
      <el-table-column
                align="right">
                <template slot-scope="scope">
                  <el-button
                            size="mini"
                            icon="el-icon-edit"
                            @click="handleEdit(scope.$index, scope.row)"></el-button>
                  <el-button
                            size="mini"
                            type="danger"
                            icon="el-icon-delete"
                            @click="handleDelete(scope.$index, scope.row)"></el-button>
                </template>
      </el-table-column>
    </el-table>
  </div>
</template>

<script>
  import { getAllTutorials, deleteTutorial, deleteAllTutorials } from '../DataProvider/dataProvider.js'

  export default {
    name: 'TutorialList',
    data() {
      return {
        tableData: [],
        search: '',
      }
    },
    mounted(){
      this.tableData = getAllTutorials()
    },
    methods: {

      handleEdit(index, row) {
        // redirected to edit page with id
        this.$router.push('/tutorial/'+ row.id)
      },

      handleDelete(index, row) {
        this.$confirm('This will permanently delete the Tutorial. Continue?', 'Warning', {
          confirmButtonText: 'Delete',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(() => {
          if(deleteTutorial(row.id))
          {
            this.showMsg('success','Delete completed')
          }else{
            this.showMsg('danger','Delete Failed')
          }
        }).catch(() => {
          this.showMsg('info','Delete canceled')
        })
      },

      handleDeleteAll(){
        this.$confirm('This will permanently delete all the Tutorials. Continue?', 'Warning', {
          confirmButtonText: 'Delete',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(() => {
          if(deleteAllTutorials())
          {
            this.showMsg('success','Delete completed')
            this.tableData = []
          }else{
            this.showMsg('danger','Delete Failed')
          }
        }).catch(() => {
          this.showMsg('info','Delete canceled')
        })
      }
    }
  }
</script>
<style scoped>
.text-cut { 
  text-overflow: ellipsis;
  overflow: hidden; 
  width: 160px; 
  height: 20px; 
  white-space: nowrap;
}
</style>

